package main

import (
	"converge/pkg/models"
	"converge/pkg/server/converge"
	"net/http"
	"strings"
)

func getConvergeAccess(r *http.Request, sshRemoteUser string) models.ConvergeAccess {
	secure := ""
	if r.TLS == nil {
		secure = ""
	} else {
		secure = "s"
	}
	for _, header := range []string{"X-Forwarded-Proto", "X-Scheme", "X-Forwarded-Scheme"} {
		values := r.Header.Values(header)
		for _, value := range values {
			if strings.ToLower(value) == "https" {
				secure = "s"
			}
		}
	}

	location, err := converge.GetUserLocation(r)
	if err != nil {
		panic(err)
	}
	return models.ConvergeAccess{
		Secure:   secure,
		HostPort: r.Host,
		Location: location,
		Username: sshRemoteUser,
	}
}
